from Def3d import *
from Materials import *
from com.sun.j3d.loaders import * 
from com.sun.j3d.loaders.objectfile import ObjectFile 
from java.io import *

def load_obj(filename):
	flags = ObjectFile.RESIZE;
	flags|= ObjectFile.TRIANGULATE;
	flags |= ObjectFile.STRIPIFY;
	f = ObjectFile(flags,(45 * Math.PI / 180.0));
	s = None;
	try :
	  s = f.load(filename);
	except FileNotFoundException: 
	  System.err.println(e);
	  System.exit(1);
	except ParsingErrorException: 
	  System.err.println(e);
	  System.exit(1);
	except IncorrectFormatException:
	  System.err.println(e);
	  System.exit(1);
	return s.getSceneGroup()

def create_scene_graph(u):
	root=BranchGroup()
	t_base=TransformGroup()
	t_base.addChild(Cylinder())
	tt_animal01=TransformGroup()
	t_animal01=TransformGroup(Transform3D(Quat4f(0,1,0,0),Vector3f(4,1,0),1.5))
	t_animal01.addChild(load_obj("modelos/pig.obj"))
	tt_animal02=TransformGroup()
	t_animal02=TransformGroup(Transform3D(Quat4f(),Vector3f(-4,1,0),1.5))
	t_animal02.addChild(load_obj("modelos/pig.obj"))
	t_base.addChild(tt_animal01)
	tt_animal01.addChild(t_animal01)
	t_base.addChild(tt_animal02)
	tt_animal02.addChild(t_animal02)
	t_base.addChild(Cylinder(5,0.5,plastic("red")))
	root.addChild(t_base)
	
	alpha=Alpha(-1,10000)
	rotint=RotationInterpolator(alpha,t_base)
	t_base.setCapability(t_base.ALLOW_TRANSFORM_WRITE)
	rotint.setSchedulingBounds(defbounds)
	root.addChild(rotint)
	
	alpha=Alpha(-1,Alpha.INCREASING_ENABLE|Alpha.DECREASING_ENABLE,
	  0,0,1000,200,0,1000,200,0)
	trint=PositionInterpolator(alpha,tt_animal01,
	  Transform3D(Matrix4f(0,1,0,0, 1,0,0,0, 0,0,1,0, 0,0,0,1)),0, 2)
	tt_animal01.setCapability(tt_animal01.ALLOW_TRANSFORM_WRITE)
	trint.setSchedulingBounds(defbounds)
	root.addChild(trint)

	trint=PositionInterpolator(alpha,tt_animal02,
	  Transform3D(Matrix4f(0,1,0,0, 1,0,0,0, 0,0,1,0, 0,0,0,1)),0, 2)
	tt_animal02.setCapability(tt_animal01.ALLOW_TRANSFORM_WRITE)
	trint.setSchedulingBounds(defbounds)
	root.addChild(trint)

	
	return root

orb=Orbiting2(create_scene_graph)
MainFrame(orb,400,400)
	
	
