from java.applet import Applet
from java.awt import *
from com.sun.j3d.utils.universe import *
from com.sun.j3d.utils.geometry import *
from com.sun.j3d.utils.applet import MainFrame
from javax.media.j3d import *
from java.lang import Math
from javax.vecmath import *
from com.sun.j3d.utils.behaviors.vp import *
from java.awt.event import *
from java.lang import Integer
from com.sun.j3d.utils.behaviors.keyboard import *
from com.sun.j3d.utils.behaviors.picking import *

defbounds=BoundingSphere(Point3d(0,0,0),80)

class Hello(Applet):
	def __init__(self,create_scene_graph):
		Applet.__init__(self)
		self.setLayout(BorderLayout())
		self.config=SimpleUniverse.getPreferredConfiguration()
		self.canvas3d=Canvas3D(self.config)
		self.add("Center", self.canvas3d)
		self.scene=create_scene_graph()
		self.scene.compile()
		self.universe=SimpleUniverse(self.canvas3d)
		self.universe.getViewingPlatform().setNominalViewingTransform()
		self.universe.addBranchGraph(self.scene)

class Hello2(Applet):
	def __init__(self,create_scene_graph):
		Applet.__init__(self)
		self.setLayout(BorderLayout())
		self.config=SimpleUniverse.getPreferredConfiguration()
		self.canvas3d=Canvas3D(self.config)
		self.add("Center", self.canvas3d)
		self.universe=SimpleUniverse(self.canvas3d)
		self.universe.getViewingPlatform().setNominalViewingTransform()
		self.scene=create_scene_graph(self.universe)
		self.scene.compile()
		self.universe.addBranchGraph(self.scene)
		
		
class Orbiting(Applet):
    def __init__(self,create_scene_graph):
	Applet.__init__(self)
	self.setLayout(BorderLayout());
        config = SimpleUniverse.getPreferredConfiguration();
        c = Canvas3D(config);
	self.add("Center", c);
	scene = create_scene_graph();
	self.u = SimpleUniverse(c);
	
	viewingPlatform = self.u.getViewingPlatform();
	pg = PlatformGeometry();

##	// Set up the ambient light
	ambientColor = Color3f(0.1, 0.1, 0.1);
	ambientLightNode = AmbientLight(ambientColor);
	ambientLightNode.setInfluencingBounds(defbounds);
	pg.addChild(ambientLightNode);

##	// Set up the directional lights
	light1Color = Color3f(1.0, 1.0, 0.9);
	light1Direction  = Vector3f(1.0, 1.0, 1.0);
	light2Color = Color3f(1.0, 1.0, 1.0);
	light2Direction  = Vector3f(-1.0, -1.0, -1.0);
	light1 = DirectionalLight(light1Color, light1Direction);
	light1.setInfluencingBounds(defbounds);
	pg.addChild(light1);
	light2 = DirectionalLight(light2Color, light2Direction);
	light2.setInfluencingBounds(defbounds);
	pg.addChild(light2);

	viewingPlatform.setPlatformGeometry( pg );
      
##	// This will move the ViewPlatform back a bit so the
##	// objects in the scene can be viewed.
	viewingPlatform.setNominalViewingTransform();

        orbit = OrbitBehavior(c,OrbitBehavior.REVERSE_ALL);
        self.boundz = BoundingSphere(Point3d(0.0, 0.0, 0.0), 100.0);
        orbit.setSchedulingBounds(defbounds);
        viewingPlatform.setViewPlatformBehavior(orbit);	    

	self.u.addBranchGraph(scene);


class Orbiting2(Applet):
    def __init__(self,create_scene_graph):
	Applet.__init__(self)
	self.setLayout(BorderLayout());
        config = SimpleUniverse.getPreferredConfiguration();
        c = Canvas3D(config);
	self.add("Center", c);
	self.u = SimpleUniverse(c);
	
	viewingPlatform = self.u.getViewingPlatform();
	pg = PlatformGeometry();

##	// Set up the ambient light
	ambientColor = Color3f(0.1, 0.1, 0.1);
	ambientLightNode = AmbientLight(ambientColor);
	ambientLightNode.setInfluencingBounds(defbounds);
	pg.addChild(ambientLightNode);

##	// Set up the directional lights
	light1Color = Color3f(1.0, 1.0, 0.9);
	light1Direction  = Vector3f(1.0, 1.0, 1.0);
	light2Color = Color3f(1.0, 1.0, 1.0);
	light2Direction  = Vector3f(-1.0, -1.0, -1.0);
	light1 = DirectionalLight(light1Color, light1Direction);
	light1.setInfluencingBounds(defbounds);
	pg.addChild(light1);
	light2 = DirectionalLight(light2Color, light2Direction);
	light2.setInfluencingBounds(defbounds);
	pg.addChild(light2);

	viewingPlatform.setPlatformGeometry( pg );
      
##	// This will move the ViewPlatform back a bit so the
##	// objects in the scene can be viewed.
	viewingPlatform.setNominalViewingTransform();

        orbit = OrbitBehavior(c,OrbitBehavior.REVERSE_ALL);
        self.boundz = BoundingSphere(Point3d(0.0, 0.0, 0.0), 100.0);
        orbit.setSchedulingBounds(defbounds);
        viewingPlatform.setViewPlatformBehavior(orbit);	    

	scene = create_scene_graph(self.u);

	self.u.addBranchGraph(scene);
	
	
def basic_scene_graph():
	objroot=BranchGroup()
	
	light=DirectionalLight(1 , Color3f(1, 1, 1), Vector3f(0.3, 0.2, -1))
	light.setInfluencingBounds(defbounds)
	
	amblight=AmbientLight(1, Color3f(1,1,1))
	amblight.setInfluencingBounds(defbounds)
	
	backg=Background(Color3f(0, 0.3, 0.7))
	backg.setApplicationBounds(defbounds)
	
	objroot.addChild(light)
	objroot.addChild(amblight)
	objroot.addChild(backg)
	return objroot

def axes_branch():
	objroot=BranchGroup()
	axisx=LineArray(2,LineArray.COORDINATES|LineArray.COLOR_3)
	axisy=LineArray(2,LineArray.COORDINATES|LineArray.COLOR_3)
	axisz=LineArray(2,LineArray.COORDINATES|LineArray.COLOR_3)
	axisz.setCoordinate(0,Point3f(0,0,0))
	axisz.setCoordinate(1,Point3f(0,0,1))
	axisz.setColor(0,Color3f(0,0.5,1))
	axisz.setColor(1,Color3f(0,0.5,1))
	axisx.setCoordinate(0,Point3f(0,0,0))
	axisx.setCoordinate(1,Point3f(1,0,0))
	axisx.setColor(0,Color3f(1,0,0.5))
	axisx.setColor(1,Color3f(1,0,0.5))
	axisy.setCoordinate(0,Point3f(0,0,0))
	axisy.setCoordinate(1,Point3f(0,1,0))
	axisy.setColor(0,Color3f(0,1,0))
	axisy.setColor(1,Color3f(0,1,0))
	objroot.addChild(Shape3D(axisx))
	objroot.addChild(Shape3D(axisy))
	objroot.addChild(Shape3D(axisz))
	return objroot

def rotation_y_vector(p1,p2):
	m3f=Matrix3f()
	v1=Vector3f(p2)
	v1.sub(p1)
	v1.normalize()
	v2=Vector3f(0,0,1)
	if(abs(v1.dot(v2)) < 0.7):
		v0=Vector3f()
		v0.cross(v2,v1)
		v2.cross(v0,v1)
	else:
		v0=Vector3f(1,0,0)
		v2.cross(v1,v0)
		v0.cross(v1,v2)
	m3f.setRow(0,v0)
	m3f.setRow(1,v1)
	m3f.setRow(2,v2)
	return m3f

