from Def3d import *

def tetraedro(P,side):
	cyan=Color3f(0,1,1)
	yellow=Color3f(1,1,0)
	magenta=Color3f(1,0,1)
	green=Color3f(0,0.7,0)
	s3d=Shape3D()
	p1=Point3f(1,0,0)
	p4=Point3f(0,0,Math.sqrt(5)/3.0)
	p2=Point3f(-1.0/3.0,2.0/3.0,0)
	p3=Point3f(-1.0/3.0,-2.0/3.0,0)
	p1.scale(side)
	p2.scale(side)
	p3.scale(side)
	p4.scale(side)
	p1.add(P)
	p2.add(P)
	p3.add(P)
	p4.add(P)
	g=TriangleArray(12,TriangleArray.COORDINATES|TriangleArray.COLOR_3)
	g.setCoordinate(0,p1), 	g.setColor(0,cyan)
	g.setCoordinate(1,p3), 	g.setColor(1,cyan)
	g.setCoordinate(2,p2), 	g.setColor(2,cyan)
	
	g.setCoordinate(3,p2), 	g.setColor(3,green)
	g.setCoordinate(4,p3), 	g.setColor(4,green)
	g.setCoordinate(5,p4), 	g.setColor(5,green)
	
	g.setCoordinate(6,p1), 	g.setColor(6,magenta)
	g.setCoordinate(7,p2), 	g.setColor(7,magenta)
	g.setCoordinate(8,p4), 	g.setColor(8,magenta)
	
	g.setCoordinate(9,p1), 	g.setColor(9,yellow)
	g.setCoordinate(10,p4),	g.setColor(10,yellow)
	g.setCoordinate(11,p3),	g.setColor(11,yellow)
	s3d.setGeometry(g)
	return s3d


def fractal(P,side,level):
	if(level>0):
		p1=Point3f(1,0,0)
		p4=Point3f(0,0,Math.sqrt(5)/3.0)
		p2=Point3f(-1.0/3.0,2.0/3.0,0)
		p3=Point3f(-1.0/3.0,-2.0/3.0,0)
		p1.scale(side/2.0)
		p2.scale(side/2.0)
		p3.scale(side/2.0)
		p4.scale(side/2.0)
		p1.add(P)
		p2.add(P)
		p3.add(P)
		p4.add(P)
		obj=BranchGroup()
		obj.addChild(fractal(p1,side/2.0,level-1))
		obj.addChild(fractal(p2,side/2.0,level-1))
		obj.addChild(fractal(p3,side/2.0,level-1))
		obj.addChild(fractal(p4,side/2.0,level-1))
		return obj
	else: return tetraedro(P,side)
		
