# Helix

from Def3d import *
from Materials import *
from java.lang import Math

def helix(p1,p2,r1, r2, phase=0.0, angdivs=16, hdivs=16,
	steps=1, caps=0, ap=plastic_red(), funct=None):
	root=BranchGroup()
	
	s3d=Shape3D()
	s3d.setAppearance(ap)
	
	h=p1.distance(p2)/steps
	
	vcount=(angdivs+1)*2*hdivs
	vertexmode=GeometryArray.COORDINATES|GeometryArray.NORMALS
	main_strip=TriangleStripArray(vcount,vertexmode,[vcount])
	print vcount
	for j in range(hdivs):
		s=j*1.0/hdivs+phase
		ss=(j+1.0)/hdivs+phase
		for i in range(angdivs+1):
			t=(i+0.0)/angdivs
			x=r1*Math.cos(t*2*Math.PI)+r2*Math.cos(2*Math.PI*s)
			y=h*(s-phase)
			z=r1*Math.sin(t*2*Math.PI)+r2*Math.sin(2*Math.PI*s)
			T1=Vector3f(-2.0*Math.PI*r1*Math.sin(2.0*Math.PI*t),
				h,
				r1*2.0*Math.PI*Math.cos(2.0*Math.PI*t))
			T2=Vector3f(-r2*2.0*Math.PI*Math.sin(2.0*Math.PI*s),
				0,
				r2*2.0*Math.PI*Math.cos(2.0*Math.PI*s))
			T1.cross(T2,T1)
			T1.normalize()
			# print [i,j,2*i+(angdivs+1)*2*j,x,y,z]
			main_strip.setCoordinate(2*i+(angdivs+1)*2*j,
				Point3f(x,y,z))
			main_strip.setNormal(2*i+(angdivs+1)*2*j,T1)
			x=r1*Math.cos(t*2*Math.PI)+r2*Math.cos(2*Math.PI*ss)
			y=h*(ss-phase)
			z=r1*Math.sin(t*2*Math.PI)+r2*Math.sin(2*Math.PI*ss)
			T1=Vector3f(-2.0*Math.PI*r1*Math.sin(2.0*Math.PI*t),
				h,
				r1*2.0*Math.PI*Math.cos(2.0*Math.PI*t))
			T2=Vector3f(-r2*2.0*Math.PI*Math.sin(2.0*Math.PI*ss),
				0,
				r2*2.0*Math.PI*Math.cos(2.0*Math.PI*ss))
			T1.cross(T2,T1)
			T1.normalize()
			# print[i,j,2*i+(angdivs+1)*2*j+1,x,y,z]
			main_strip.setCoordinate(2*i+(angdivs+1)*2*j+1,
				Point3f(x,y,z))
			main_strip.setNormal(2*i+(angdivs+1)*2*j+1,T1)
	s3d.setGeometry(main_strip)
	
	if caps: s3d.addGeometry(caps_1)
	if caps: s3d.addGeometry(caps_2)
	
	m3f=rotation_y_vector(p1, p2)
	t3d=Transform3D(Matrix3f(m3f),Vector3f(p1),1.0)
	
	tg=TransformGroup(t3d)
	
	tg.addChild(s3d)
	root.addChild(tg)
	return root

