from com.sun.j3d.loaders.objectfile import ObjectFile
from com.sun.j3d.loaders import ParsingErrorException
from  com.sun.j3d.loaders import IncorrectFormatException
from  com.sun.j3d.loaders import Scene
from  java.applet import Applet
from  java.awt import *
from  java.awt.event import *
from  com.sun.j3d.utils.applet import MainFrame
from  com.sun.j3d.utils.universe import *
from  javax.media.j3d import *
from  javax.vecmath import *
from  java.io import *
from  com.sun.j3d.utils.behaviors.vp import *
from  java.net import URL
from  java.net import MalformedURLException
from java.lang import System, Math

False=None
false=None
null=None
System.out.println("Test")

spin = False;
noTriangulate = False;
noStripify = False;
creaseAngle = 60.0;
filename = "./galleon.obj";


class ObjLoad(Applet):

    def createSceneGraph(self) :
##	// Create the root of the branch graph
	objRoot = BranchGroup()

##        // Create a Transformgroup to scale all objects so they
##        // appear in the scene.
        objScale = TransformGroup();
        t3d = Transform3D();
        t3d.setScale(0.7);
        objScale.setTransform(t3d);
        objRoot.addChild(objScale);

##	// Create the transform group node and initialize it to the
##	// identity.  Enable the TRANSFORM_WRITE capability so that
##	// our behavior code can modify it at runtime.  Add it to the
##	// root of the subgraph.
	objTrans = TransformGroup();
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	objScale.addChild(objTrans);

	flags = ObjectFile.RESIZE;
	if (not noTriangulate): flags |= ObjectFile.TRIANGULATE;
	if (not noStripify): flags |= ObjectFile.STRIPIFY;
	f = ObjectFile(flags, 
	  (float)(creaseAngle * Math.PI / 180.0));
	s = None;
	try :
	  s = f.load(filename);
	except FileNotFoundException: 
	  System.err.println("File not found");
	  System.exit(1);
	except ParsingErrorException: 
	  System.err.println("Parse error");
	  System.exit(1);
	except IncorrectFormatException:
	  System.err.println("Incorrect Format");
	  System.exit(1);
	
	
	objTrans.addChild(s.getSceneGroup());

	self.boundz = BoundingSphere(Point3d(0.0,0.0,0.0), 100.0);

        if (spin): 
	  yAxis = Transform3D();
	  rotationAlpha = Alpha(-1, Alpha.INCREASING_ENABLE,
					  0, 0,
					  4000, 0, 0,
					  0, 0, 0);

	  rotator = \
	      RotationInterpolator(rotationAlpha, objTrans, yAxis, \
				       0.0, Math.PI*2.0);
	  rotator.setSchedulingBounds(self.boundz);
	  objTrans.addChild(rotator);
	 

##        // Set up the background
        bgColor = Color3f(0.05, 0.05, 0.5);
        bgNode = Background(bgColor);
        bgNode.setApplicationBounds(self.boundz);
        objRoot.addChild(bgNode);

	return objRoot;
    

    def usage():
      System.out.println("")
      System.exit(0);

    def init(self): 
        filename="galleon.obj"
	
	self.setLayout(BorderLayout());
        config = SimpleUniverse.getPreferredConfiguration();

        c = Canvas3D(config);
	self.add("Center", c);

##	// Create a simple scene and attach it to the virtual universe
	scene = self.createSceneGraph();
	self.u = SimpleUniverse(c);
	
##	// add mouse behaviors to the ViewingPlatform
	viewingPlatform = self.u.getViewingPlatform();

	pg = PlatformGeometry();

##	// Set up the ambient light
	ambientColor = Color3f(0.1, 0.1, 0.1);
	ambientLightNode = AmbientLight(ambientColor);
	ambientLightNode.setInfluencingBounds(self.boundz);
	pg.addChild(ambientLightNode);

##	// Set up the directional lights
	light1Color = Color3f(1.0, 1.0, 0.9);
	light1Direction  = Vector3f(1.0, 1.0, 1.0);
	light2Color = Color3f(1.0, 1.0, 1.0);
	light2Direction  = Vector3f(-1.0, -1.0, -1.0);

	light1 = DirectionalLight(light1Color, light1Direction);
	light1.setInfluencingBounds(self.boundz);
	pg.addChild(light1);

	light2 = DirectionalLight(light2Color, light2Direction);
	light2.setInfluencingBounds(self.boundz);
	pg.addChild(light2);

	viewingPlatform.setPlatformGeometry( pg );
      
##	// This will move the ViewPlatform back a bit so the
##	// objects in the scene can be viewed.
	viewingPlatform.setNominalViewingTransform();

	if ( not spin): 
            orbit = OrbitBehavior(c,OrbitBehavior.REVERSE_ALL);
            self.boundz = BoundingSphere(Point3d(0.0, 0.0, 0.0), 100.0);
            orbit.setSchedulingBounds(self.boundz);
            viewingPlatform.setViewPlatformBehavior(orbit);	    
	

	self.u.addBranchGraph(scene);
    
    def destroy(self):
	self.u.cleanup()

MainFrame(ObjLoad(), 700, 700);

